--[[
 Final score mal posicionado,
 Raio da dano na casa (?),
 Boost baseado na pontuação, ou qtd de acertos em sequência,
 Mostrar quando o boost liberou
]]

io.stdout:setvbuf("no")
local rain = require "rain"
local house = require "house"
local player = require "player"
local flash = require "flash"
local state = 1

local function resetGame()
  state = nil
  flash.load()
  rain.load()
  house.load()
  player.load()
end

function love.load()
  local s = love.graphics.getPointSize() + 2
  love.graphics.setPointSize(s)
  
  font1 = love.graphics.newFont(50)
  font2 = love.graphics.newFont(20)
  font3 = love.graphics.newFont(40)
  font4 = love.graphics.newFont(15)
  
  rainVolume = 0.1
  rainAudio = love.audio.newSource("heavy-rain.mp3", "stream")
  rainAudio:setVolume(rainVolume)
  rainAudio:setLooping(true)
  love.audio.play(rainAudio)
  
  brickAudio = love.audio.newSource("brick.wav", "static")
  brickAudio:setVolume(0.5)
  thunderAudio = love.audio.newSource("thunder.mp3", "static")
  thunderAudio:setVolume(0.8)
  
  -- Global variables
  winWidth = love.graphics.getWidth()
  winHeight = love.graphics.getHeight()
  
  -- Load calls
  flash.load()
  rain.load()
  house.load()
  player.load()
end

function love.update(dt)
  flash.update(dt)
  rain.update(dt)
  
  if state then
    return
  end
  
  if house.floodLvl >= house.floodLimit then
    state = 2
  end
  
  house.update(dt)
  player.update(dt)
end

function love.keypressed(key)
  if key == "return" then
    if state == 1 then
      resetGame()
    elseif state == 2 then
      state = 1
    end
  end
end

function love.draw()
  local gr = love.graphics
  flash.draw()
  rain.draw()
  

  if state == 1 then
    -- Flash Animation
    gr.setColor(0, 0, 0, 0.5)
    gr.rectangle("fill", 0, 0, winWidth, winHeight)
    
    gr.setColor(1, 1, 1)
    gr.setFont(font1)
    gr.printf("Blockin' Flood", 0, winHeight/3, winWidth, "center")
    gr.setFont(font2)
    gr.printf(">> Press 'Enter' to Play <<", 0, winHeight/2, winWidth, "center")
  elseif state == 2 then
    -- Flash Animation
    gr.setColor(0, 0, 0, 0.5)
    gr.rectangle("fill", 0, 0, winWidth, winHeight)
    
    gr.setColor(1, 1, 1)
    gr.setFont(font3)
    gr.printf("GAME OVER", 0, winHeight/3, winWidth, "center")
    gr.setFont(font4)
    gr.printf(string.format("Final Score: %06d", player.score), 0, winHeight/3, winWidth, "center")
    gr.setFont(font2)
    gr.printf(">> Press 'Enter' to Restart <<", 0, winHeight/2, winWidth, "center")
  else
    player.draw()
    house.draw()
  end
end
