local rain = {}
local randLimit
local gravity = 200

function rain.load()
  rain.drops = {}
  rain.maxLimit = 0.4
  rain.time = 0
  rain.timeLimit = 0
  rain.offset = 10
  rain.color = {28/255,163/255,236/255}
  randLimit = math.random(rain.maxLimit)
end

function rain.update(dt)
  rain.time = rain.time + dt
  rain.timeLimit = rain.timeLimit + dt
  
  if rain.time > randLimit then
    local maxWidth = winWidth - rain.offset
    local randX = math.random(rain.offset, maxWidth)
    rain.time = 0
    randLimit = math.random(1, rain.maxLimit*100)/100
    table.insert(rain.drops, {x=randX, y=-2, vel=200})
  end
  
  if rain.timeLimit > 2 then
    rain.maxLimit = rain.maxLimit > 0.01 and rain.maxLimit - 0.01 or rain.maxLimit
    rainVolume = rainVolume < 1 and rainVolume + 0.1 or rainVolume
    rain.timeLimit = 0
  end
  
  for i=1, #rain.drops do
    local curr = rain.drops[i]
    curr.vel = curr.vel + gravity*dt
    curr.y = curr.y + curr.vel*dt
  end
  
  for i=#rain.drops, 1, -1 do
    local curr = rain.drops[i]
    if curr.y > winHeight then
      table.remove(rain.drops, i)
    end
  end
end

function rain.draw()
  love.graphics.setColor(rain.color)
  for i=1, #rain.drops do
    local curr = rain.drops[i]
    for j=1, 3 do
      love.graphics.points(curr.x, curr.y - 5*j)
    end
  end
end

return rain